11.Container With Most Water

LeetCode

原题

Given n non-negative integers a1, a2, ..., an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2. 11.Container With Most Water The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49. Example:

Input: [1,8,6,2,5,4,8,3,7]
Output: 49

解决

暴力法

遍历出每一个容器的储水量,即可知道最大的储水值是多少。

class Solution {
    public int maxArea(int[] height) {
        int points = height.length;
        int max = 0;
        for(int i = 0; i < points; i ++) {
            for(int j = i + 1; j < points; j ++) {
                max = Math.max((j - i) * Math.min(height[i], height[j]), max);
            }
        }
        return max;
    }

}

双指针

使用双指针可以只进行一次扫描。两个指针一个在头一个在尾。由于长度越长,面积也越大,同时面积又受到较短的那个值影响。因此可以在缩短距离时,可以通过增加高度,来避免由于长度变短而造成的面积减小的影响。

class Solution {
    public int maxArea(int[] height) {
        int points = height.length;
        int max = 0, i = 0, j = points - 1;
        while(i < j) {
            max = Math.max((j - i) * Math.min(height[i], height[j]), max);
            if(height[i] > height[j]) {
                j --;
            } else {
                i ++;
            }
        }
        return max;
    }    
}